Index: frontends/php/include/actions.inc.php
===================================================================
--- frontends/php/include/actions.inc.php	(revision 38884)
+++ frontends/php/include/actions.inc.php	(working copy)
@@ -27,13 +27,13 @@
 
 	$result = false;
 
-	if(DBselect('select actionid from actions where actionid='.$actionid.' and '.DBin_node('actionid'))){
+	if(DBselect('select actionid from actions where actionid='.zbx_dbstr($actionid).' and '.DBin_node('actionid'))){
 		$result = true;
 
 		$available_hosts = get_accessible_hosts_by_user($USER_DETAILS,$perm,null,get_current_nodeid(true));
 		$available_groups = get_accessible_groups_by_user($USER_DETAILS,$perm,null,get_current_nodeid(true));
 
-		$db_result = DBselect('SELECT * FROM conditions WHERE actionid='.$actionid);
+		$db_result = DBselect('SELECT * FROM conditions WHERE actionid='.zbx_dbstr($actionid));
 		while(($ac_data = DBfetch($db_result)) && $result){
 			if($ac_data['operator'] != 0) continue;
 
@@ -52,7 +52,7 @@
 				case CONDITION_TYPE_TRIGGER:
 					$sql = 'SELECT DISTINCT t.triggerid'.
 						' FROM triggers t,items i,functions f '.
-						' WHERE t.triggerid='.$ac_data['value'].
+						' WHERE t.triggerid='.zbx_dbstr($ac_data['value']).
 							' AND f.triggerid=t.triggerid'.
 							' AND i.itemid=f.itemid '.
 							' AND '.DBcondition('i.hostid',$available_hosts, true);
@@ -135,7 +135,7 @@
 }
 
 function get_action_by_actionid($actionid){
-	$sql='select * from actions where actionid='.$actionid;
+	$sql='select * from actions where actionid='.zbx_dbstr($actionid);
 	$result=DBselect($sql);
 
 	if($row=DBfetch($result)){
@@ -148,7 +148,7 @@
 }
 
 function get_operations_by_actionid($actionid){
-	$sql='SELECT * FROM operations WHERE actionid='.$actionid;
+	$sql='SELECT * FROM operations WHERE actionid='.zbx_dbstr($actionid);
 	$result=DBselect($sql);
 
 return	$result;
@@ -161,9 +161,9 @@
 	$conditionid = get_dbid("conditions","conditionid");
 
 	$result = DBexecute('INSERT INTO conditions (conditionid,actionid,conditiontype,operator,value)'.
-		' values ('.$conditionid.','.$actionid.','.
-			$condition['type'].','.
-			$condition['operator'].','.
+		' values ('.$conditionid.','.zbx_dbstr($actionid).','.
+			zbx_dbstr($condition['type']).','.
+			zbx_dbstr($condition['operator']).','.
 			zbx_dbstr($condition['value']).
 		')');
 
@@ -180,17 +180,17 @@
 	if(!isset($operation['opconditions'])) $operation['opconditions'] = array();
 
 	$result = DBexecute('INSERT INTO operations (operationid, actionid, operationtype, object, objectid, shortdata, longdata, esc_period, esc_step_from, esc_step_to, default_msg, evaltype)'.
-		' values('.$operationid.','.$actionid.','.
-			$operation['operationtype'].','.
-			$operation['object'].','.
-			$operation['objectid'].','.
+		' values('.$operationid.','.zbx_dbstr($actionid).','.
+			zbx_dbstr($operation['operationtype']).','.
+			zbx_dbstr($operation['object']).','.
+			zbx_dbstr($operation['objectid']).','.
 			zbx_dbstr($operation['shortdata']).','.
 			zbx_dbstr($operation['longdata']).','.
-			$operation['esc_period'].','.
-			$operation['esc_step_from'].','.
-			$operation['esc_step_to'].','.
-			$operation['default_msg'].','.
-			$operation['evaltype'].
+			zbx_dbstr($operation['esc_period']).','.
+			zbx_dbstr($operation['esc_step_from']).','.
+			zbx_dbstr($operation['esc_step_to']).','.
+			zbx_dbstr($operation['default_msg']).','.
+			zbx_dbstr($operation['evaltype']).
 		')');
 	if(!$result)
 		return $result;
@@ -210,9 +210,9 @@
 
 	$result = DBexecute('INSERT INTO opconditions (opconditionid,operationid,conditiontype,operator,value)'.
 		' values ('.$opconditionid.','.
-			$operationid.','.
-			$opcondition['conditiontype'].','.
-			$opcondition['operator'].','.
+			zbx_dbstr($operationid).','.
+			zbx_dbstr($opcondition['conditiontype']).','.
+			zbx_dbstr($opcondition['operator']).','.
 			zbx_dbstr($opcondition['value']).
 		')');
 
@@ -230,7 +230,7 @@
 	$opmediatypeid = get_dbid('opmediatypes', 'opmediatypeid');
 
 	$result = DBexecute('INSERT INTO opmediatypes (opmediatypeid,operationid,mediatypeid)'.
-		' values ('.$opmediatypeid.','.$operationid.','.$mediatypeid.')');
+		' values ('.$opmediatypeid.','.zbx_dbstr($operationid).','.zbx_dbstr($mediatypeid).')');
 
 	if(!$result)
 		return $result;
@@ -266,7 +266,7 @@
 	$actionid=get_dbid('actions','actionid');
 
 	$result = DBexecute('INSERT INTO actions (actionid,name,eventsource,esc_period,def_shortdata,def_longdata,recovery_msg,r_shortdata,r_longdata,evaltype,status)'.
-				' VALUES ('.$actionid.','.zbx_dbstr($name).','.$eventsource.','.$esc_period.','.zbx_dbstr($def_shortdata).','.zbx_dbstr($def_longdata).','.$recovery_msg.','.zbx_dbstr($r_shortdata).','.zbx_dbstr($r_longdata).','.$evaltype.','.$status.')');
+				' VALUES ('.$actionid.','.zbx_dbstr($name).','.zbx_dbstr($eventsource).','.zbx_dbstr($esc_period).','.zbx_dbstr($def_shortdata).','.zbx_dbstr($def_longdata).','.zbx_dbstr($recovery_msg).','.zbx_dbstr($r_shortdata).','.zbx_dbstr($r_longdata).','.zbx_dbstr($evaltype).','.zbx_dbstr($status).')');
 
 	foreach($operations as $operation)
 		if(!$result = add_action_operation($actionid, $operation))
@@ -313,26 +313,26 @@
 	}
 
 	$result = DBexecute('UPDATE actions SET name='.zbx_dbstr($name).
-							',eventsource='.$eventsource.
-							',esc_period='.$esc_period.
+							',eventsource='.zbx_dbstr($eventsource).
+							',esc_period='.zbx_dbstr($esc_period).
 							',def_shortdata='.zbx_dbstr($def_shortdata).
 							',def_longdata='.zbx_dbstr($def_longdata).
-							',recovery_msg='.$recovery_msg.
+							',recovery_msg='.zbx_dbstr($recovery_msg).
 							',r_shortdata='.zbx_dbstr($r_shortdata).
 							',r_longdata='.zbx_dbstr($r_longdata).
-							',evaltype='.$evaltype.
-							',status='.$status.
-						' WHERE actionid='.$actionid);
+							',evaltype='.zbx_dbstr($evaltype).
+							',status='.zbx_dbstr($status).
+						' WHERE actionid='.zbx_dbstr($actionid));
 
 	if($result){
-		DBexecute('DELETE FROM conditions WHERE actionid='.$actionid);
+		DBexecute('DELETE FROM conditions WHERE actionid='.zbx_dbstr($actionid));
 
 		$opers = get_operations_by_actionid($actionid);
 		while($operation = DBFetch($opers)){
-			DBexecute('DELETE FROM opconditions WHERE operationid='.$operation['operationid']);
-			DBexecute('DELETE FROM opmediatypes WHERE operationid='.$operation['operationid']);
+			DBexecute('DELETE FROM opconditions WHERE operationid='.zbx_dbstr($operation['operationid']));
+			DBexecute('DELETE FROM opmediatypes WHERE operationid='.zbx_dbstr($operation['operationid']));
 		}
-		DBexecute('DELETE FROM operations WHERE actionid='.$actionid);
+		DBexecute('DELETE FROM operations WHERE actionid='.zbx_dbstr($actionid));
 
 
 		foreach($operations as $operation)
@@ -352,7 +352,7 @@
 // Delete Action
 
 function delete_action( $actionid ){
-	$return = DBexecute('delete from conditions where actionid='.$actionid);
+	$return = DBexecute('delete from conditions where actionid='.zbx_dbstr($actionid));
 
 	$opers = get_operations_by_actionid($actionid);
 	while($operation = DBFetch($opers)){
@@ -361,13 +361,13 @@
 	}
 
 	if($return)
-		$result = DBexecute('delete from operations where actionid='.$actionid);
+		$result = DBexecute('delete from operations where actionid='.zbx_dbstr($actionid));
 
 	if($return)
-		$result = DBexecute('delete from alerts where actionid='.$actionid);
+		$result = DBexecute('delete from alerts where actionid='.zbx_dbstr($actionid));
 
 	if($return)
-		$result = DBexecute('delete from actions where actionid='.$actionid);
+		$result = DBexecute('delete from actions where actionid='.zbx_dbstr($actionid));
 
 return $result;
 }
@@ -474,7 +474,7 @@
 			break;
 		case CONDITION_TYPE_DCHECK:
 			$row = DBfetch(DBselect('SELECT DISTINCT r.name,c.dcheckid,c.type,c.key_,c.snmp_community,c.ports'.
-					' FROM drules r,dchecks c WHERE r.druleid=c.druleid AND c.dcheckid='.$value));
+					' FROM drules r,dchecks c WHERE r.druleid=c.druleid AND c.dcheckid='.zbx_dbstr($value)));
 			$str_val = $row['name'].':'.discovery_check2str($row['type'],
 					$row['snmp_community'], $row['key_'], $row['ports']);
 			break;
@@ -597,7 +597,7 @@
 							$sql = 'SELECT a.def_shortdata,a.def_longdata '.
 									' FROM actions a, operations o '.
 									' WHERE a.actionid=o.actionid '.
-										' AND o.operationid='.$data['operationid'];
+										' AND o.operationid='.zbx_dbstr($data['operationid']);
 							if($rows = DBfetch(DBselect($sql,1))){
 								$temp = bold(S_SUBJECT.': ');
 								$result = $temp->ToString()."\n".$rows['def_shortdata']."\n";
@@ -839,7 +839,7 @@
 
 function	update_action_status($actionid, $status)
 {
-	return DBexecute("update actions set status=$status where actionid=$actionid");
+	return DBexecute('update actions set status='.zbx_dbstr($status).' where actionid='.zbx_dbstr($actionid));
 }
 
 function validate_condition($conditiontype, $value){
@@ -861,7 +861,7 @@
 			}
 			break;
 		case CONDITION_TYPE_TRIGGER:
-			if( !DBfetch(DBselect('select triggerid from triggers where triggerid='.$value)) ||
+			if( !DBfetch(DBselect('select triggerid from triggers where triggerid='.zbx_dbstr($value))) ||
 				!check_right_on_trigger_by_triggerid(PERM_READ_ONLY, $value) )
 			{
 				error(S_INCORRECT_TRIGGER);
@@ -1259,7 +1259,7 @@
 	$hostids = array();
 	$sql = 'SELECT DISTINCT i.hostid '.
 			' FROM events e, functions f, items i '.
-			' WHERE e.eventid='.$eventid.
+			' WHERE e.eventid='.zbx_dbstr($eventid).
 				' AND e.object='.EVENT_SOURCE_TRIGGERS.
 				' AND f.triggerid=e.objectid '.
 				' AND i.itemid=f.itemid';
@@ -1293,8 +1293,8 @@
 			' FROM events e,alerts a '.
 				' LEFT JOIN users u ON u.userid=a.userid '.
 				' LEFT JOIN media_type mt ON mt.mediatypeid=a.mediatypeid'.
-			' WHERE a.eventid='.$eventid.
-				(is_null($status)?'':' AND a.status='.$status).
+			' WHERE a.eventid='.zbx_dbstr($eventid).
+				(is_null($status)?'':' AND a.status='.zbx_dbstr($status)).
 				' AND e.eventid = a.eventid'.
 				' AND a.alerttype IN ('.ALERT_TYPE_MESSAGE.','.ALERT_TYPE_COMMAND.')'.
 				' AND '.DBcondition('e.objectid',$available_triggers).
@@ -1349,7 +1349,7 @@
 
 	$sql='SELECT COUNT(a.alertid) as cnt_all'.
 			' FROM alerts a '.
-			' WHERE a.eventid='.$eventid.
+			' WHERE a.eventid='.zbx_dbstr($eventid).
 				' AND a.alerttype in ('.ALERT_TYPE_MESSAGE.','.ALERT_TYPE_COMMAND.')';
 
 	$alerts=DBfetch(DBselect($sql));
@@ -1359,7 +1359,7 @@
 // Sent
 		$sql='SELECT COUNT(a.alertid) as sent '.
 				' FROM alerts a '.
-				' WHERE a.eventid='.$eventid.
+				' WHERE a.eventid='.zbx_dbstr($eventid).
 					' AND a.alerttype in ('.ALERT_TYPE_MESSAGE.','.ALERT_TYPE_COMMAND.')'.
 					' AND a.status='.ALERT_STATUS_SENT;
 
@@ -1369,7 +1369,7 @@
 // In progress
 		$sql='SELECT COUNT(a.alertid) as inprogress '.
 				' FROM alerts a '.
-				' WHERE a.eventid='.$eventid.
+				' WHERE a.eventid='.zbx_dbstr($eventid).
 					' AND a.alerttype in ('.ALERT_TYPE_MESSAGE.','.ALERT_TYPE_COMMAND.')'.
 					' AND a.status='.ALERT_STATUS_NOT_SENT;
 
@@ -1378,7 +1378,7 @@
 // Failed
 		$sql='SELECT COUNT(a.alertid) as failed '.
 				' FROM alerts a '.
-				' WHERE a.eventid='.$eventid.
+				' WHERE a.eventid='.zbx_dbstr($eventid).
 					' AND a.alerttype in ('.ALERT_TYPE_MESSAGE.','.ALERT_TYPE_COMMAND.')'.
 					' AND a.status='.ALERT_STATUS_FAILED;
 
@@ -1416,7 +1416,7 @@
 
 	$sql='SELECT COUNT(a.alertid) as cnt '.
 			' FROM alerts a '.
-			' WHERE a.eventid='.$eventid.
+			' WHERE a.eventid='.zbx_dbstr($eventid).
 				' AND a.alerttype in ('.ALERT_TYPE_MESSAGE.','.ALERT_TYPE_COMMAND.')';
 
 
@@ -1425,7 +1425,7 @@
 	if(isset($alerts['cnt']) && ($alerts['cnt'] > 0)){
 		$sql='SELECT COUNT(a.alertid) as sent '.
 				' FROM alerts a '.
-				' WHERE a.eventid='.$eventid.
+				' WHERE a.eventid='.zbx_dbstr($eventid).
 					' AND a.alerttype in ('.ALERT_TYPE_MESSAGE.','.ALERT_TYPE_COMMAND.')'.
 					' AND a.status='.ALERT_STATUS_SENT;
 
@@ -1441,7 +1441,7 @@
 
 		$sql='SELECT COUNT(a.alertid) as inprogress '.
 				' FROM alerts a '.
-				' WHERE a.eventid='.$eventid.
+				' WHERE a.eventid='.zbx_dbstr($eventid).
 					' AND a.alerttype in ('.ALERT_TYPE_MESSAGE.','.ALERT_TYPE_COMMAND.')'.
 					' AND a.status='.ALERT_STATUS_NOT_SENT;
 
@@ -1457,7 +1457,7 @@
 
 		$sql='SELECT COUNT(a.alertid) as failed '.
 				' FROM alerts a '.
-				' WHERE a.eventid='.$eventid.
+				' WHERE a.eventid='.zbx_dbstr($eventid).
 					' AND a.alerttype in ('.ALERT_TYPE_MESSAGE.','.ALERT_TYPE_COMMAND.')'.
 					' AND a.status='.ALERT_STATUS_FAILED;
 
Index: frontends/php/include/screens.inc.php
===================================================================
--- frontends/php/include/screens.inc.php	(revision 38884)
+++ frontends/php/include/screens.inc.php	(working copy)
@@ -29,10 +29,10 @@
 
 		$result = false;
 
-		if(DBfetch(DBselect('SELECT screenid FROM screens WHERE screenid='.$screenid.' AND '.DBin_node('screenid', get_current_nodeid($perm))))){
+		if(DBfetch(DBselect('SELECT screenid FROM screens WHERE screenid='.zbx_dbstr($screenid).' AND '.DBin_node('screenid', get_current_nodeid($perm))))){
 			$result = true;
 
-			$db_result = DBselect('SELECT * FROM screens_items WHERE screenid='.$screenid);
+			$db_result = DBselect('SELECT * FROM screens_items WHERE screenid='.zbx_dbstr($screenid));
 			while(($ac_data = DBfetch($db_result)) && $result){
 				if($ac_data['resourceid'] == 0) continue;
 
@@ -113,16 +113,16 @@
 	}
 */
 	function delete_screen($screenid){
-		$result=DBexecute('DELETE FROM screens_items where screenid='.$screenid);
-		$result&=DBexecute('DELETE FROM screens_items where resourceid='.$screenid.' and resourcetype='.SCREEN_RESOURCE_SCREEN);
-		$result&=DBexecute('DELETE FROM slides where screenid='.$screenid);
-		$result&=DBexecute("DELETE FROM profiles WHERE idx='web.favorite.screenids' AND source='screenid' AND value_id=$screenid");
-		$result&=DBexecute('DELETE FROM screens where screenid='.$screenid);
+		$result=DBexecute('DELETE FROM screens_items where screenid='.zbx_dbstr($screenid));
+		$result&=DBexecute('DELETE FROM screens_items where resourceid='.zbx_dbstr($screenid).' and resourcetype='.SCREEN_RESOURCE_SCREEN);
+		$result&=DBexecute('DELETE FROM slides where screenid='.zbx_dbstr($screenid));
+		$result&=DBexecute("DELETE FROM profiles WHERE idx='web.favorite.screenids' AND source='screenid' AND value_id=".zbx_dbstr($screenid));
+		$result&=DBexecute('DELETE FROM screens where screenid='.zbx_dbstr($screenid));
 	return	$result;
 	}
 
 	function add_screen_item($resourcetype,$screenid,$x,$y,$resourceid,$width,$height,$colspan,$rowspan,$elements,$valign,$halign,$style,$url,$dynamic){
-		$sql='DELETE FROM screens_items WHERE screenid='.$screenid.' and x='.$x.' and y='.$y;
+		$sql='DELETE FROM screens_items WHERE screenid='.zbx_dbstr($screenid).' and x='.zbx_dbstr($x).' and y='.zbx_dbstr($y);
 		DBexecute($sql);
 
 		$screenitemid=get_dbid("screens_items","screenitemid");
@@ -130,8 +130,8 @@
 							'(screenitemid,resourcetype,screenid,x,y,resourceid,width,height,'.
 							' colspan,rowspan,elements,valign,halign,style,url,dynamic) '.
 						' VALUES '.
-							"($screenitemid,$resourcetype,$screenid,$x,$y,$resourceid,$width,$height,$colspan,".
-							"$rowspan,$elements,$valign,$halign,$style,".zbx_dbstr($url).",$dynamic)");
+							"(".zbx_dbstr($screenitemid).",".zbx_dbstr($resourcetype).",".zbx_dbstr($screenid).",".zbx_dbstr($x).",".zbx_dbstr($y).",".zbx_dbstr($resourceid).",".zbx_dbstr($width).",".zbx_dbstr($height).",".zbx_dbstr($colspan).",".
+							zbx_dbstr($rowspan).",".zbx_dbstr($elements).",".zbx_dbstr($valign).",".zbx_dbstr($halign).",".zbx_dbstr($style).",".zbx_dbstr($url).",".zbx_dbstr($dynamic).")");
 
 		if(!$result) return $result;
 	return $screenitemid;
@@ -139,19 +139,19 @@
 
 	function update_screen_item($screenitemid,$resourcetype,$resourceid,$width,$height,$colspan,$rowspan,$elements,$valign,$halign,$style,$url,$dynamic){
 		return  DBexecute("UPDATE screens_items SET ".
-							"resourcetype=$resourcetype,"."resourceid=$resourceid,"."width=$width,".
-							"height=$height,colspan=$colspan,rowspan=$rowspan,elements=$elements,".
-							"valign=$valign,halign=$halign,style=$style,url=".zbx_dbstr($url).",dynamic=$dynamic".
-						" WHERE screenitemid=$screenitemid");
+							"resourcetype=".zbx_dbstr($resourcetype).","."resourceid=".zbx_dbstr($resourceid).","."width=".zbx_dbstr($width).",".
+							"height=".zbx_dbstr($height).",colspan=".zbx_dbstr($colspan).",rowspan=".zbx_dbstr($rowspan).",elements=".zbx_dbstr($elements).",".
+							"valign=".zbx_dbstr($valign).",halign=".zbx_dbstr($halign).",style=".zbx_dbstr($style).",url=".zbx_dbstr($url).",dynamic=".zbx_dbstr($dynamic).
+						" WHERE screenitemid=".zbx_dbstr($screenitemid));
 	}
 
 	function delete_screen_item($screenitemid){
-		$sql="DELETE FROM screens_items where screenitemid=$screenitemid";
+		$sql="DELETE FROM screens_items where screenitemid=".zbx_dbstr($screenitemid);
 	return  DBexecute($sql);
 	}
 
 	function get_screen_by_screenid($screenid){
-		$result = DBselect("select * from screens where screenid=$screenid");
+		$result = DBselect('select * from screens where screenid='.zbx_dbstr($screenid));
 		$row=DBfetch($result);
 		if($row){
 			return	$row;
@@ -163,8 +163,7 @@
 	function check_screen_recursion($mother_screenid, $child_screenid){
 		if((bccomp($mother_screenid , $child_screenid)==0))	return TRUE;
 
-		$db_scr_items = DBselect("select resourceid from screens_items where".
-			" screenid=$child_screenid and resourcetype=".SCREEN_RESOURCE_SCREEN);
+		$db_scr_items = DBselect('select resourceid from screens_items where screenid='.zbx_dbstr($child_screenid).' and resourcetype='.SCREEN_RESOURCE_SCREEN);
 		while($scr_item = DBfetch($db_scr_items)){
 			if(check_screen_recursion($mother_screenid,$scr_item["resourceid"]))
 				return TRUE;
@@ -175,7 +174,7 @@
 	function get_slideshow($slideshowid, $step, $effectiveperiod=NULL){
 		$sql = 'SELECT min(step) as min_step, max(step) as max_step '.
 				' FROM slides '.
-				' WHERE slideshowid='.$slideshowid;
+				' WHERE slideshowid='.zbx_dbstr($slideshowid);
 		$slide_data = DBfetch(DBselect($sql));
 		if(!$slide_data || is_null($slide_data['min_step'])){
 			return false;
@@ -191,9 +190,9 @@
 
 		$sql = 'SELECT sl.* '.
 				' FROM slides sl, slideshows ss '.
-				' WHERE ss.slideshowid='.$slideshowid.
+				' WHERE ss.slideshowid='.zbx_dbstr($slideshowid).
 					' and sl.slideshowid=ss.slideshowid '.
-					' and sl.step='.$curr_step;
+					' and sl.step='.zbx_dbstr($curr_step);
 		$slide_data = DBfetch(DBselect($sql));
 
 	return $slide_data;
@@ -205,7 +204,7 @@
 
 		$sql = 'SELECT slideshowid '.
 				' FROM slideshows '.
-				' WHERE slideshowid='.$slideshowid.
+				' WHERE slideshowid='.zbx_dbstr($slideshowid).
 					' AND '.DBin_node('slideshowid', get_current_nodeid(null,$perm));
 		if(DBselect($sql)){
 			$result = true;
@@ -213,7 +212,7 @@
 			$screenids = array();
 			$sql = 'SELECT DISTINCT screenid '.
 					' FROM slides '.
-					' WHERE slideshowid='.$slideshowid;
+					' WHERE slideshowid='.zbx_dbstr($slideshowid);
 			$db_screens = DBselect($sql);
 			while($slide_data = DBfetch($db_screens)){
 				$screenids[$slide_data['screenid']] = $slide_data['screenid'];
@@ -236,7 +235,7 @@
 	}
 
 	function get_slideshow_by_slideshowid($slideshowid){
-		return DBfetch(DBselect('select * from slideshows where slideshowid='.$slideshowid));
+		return DBfetch(DBselect('select * from slideshows where slideshowid='.zbx_dbstr($slideshowid)));
 	}
 
 	function validate_slide(&$slide){
@@ -253,7 +252,7 @@
 
 		$slideshowid = get_dbid('slideshows','slideshowid');
 		$result = DBexecute('INSERT INTO slideshows (slideshowid,name,delay) '.
-							' VALUES ('.$slideshowid.','.zbx_dbstr($name).','.$delay.')');
+							' VALUES ('.$slideshowid.','.zbx_dbstr($name).','.zbx_dbstr($delay).')');
 
 		$i = 0;
 		foreach($slides as $num => $slide){
@@ -261,7 +260,7 @@
 
 // TODO: resulve conflict about regression of delay per slide
 			$result = DBexecute('INSERT INTO slides (slideid,slideshowid,screenid,step,delay) '.
-								' VALUES ('.$slideid.','.$slideshowid.','.$slide['screenid'].','.($i++).','.$slide['delay'].')');
+								' VALUES ('.$slideid.','.zbx_dbstr($slideshowid).','.zbx_dbstr($slide['screenid']).','.($i++).','.zbx_dbstr($slide['delay']).')');
 			if(!$result) return false;
 		}
 
@@ -274,17 +273,17 @@
 				return false;
 		}
 
-		if(!$result = DBexecute('UPDATE slideshows SET name='.zbx_dbstr($name).',delay='.$delay.' WHERE slideshowid='.$slideshowid))
+		if(!$result = DBexecute('UPDATE slideshows SET name='.zbx_dbstr($name).',delay='.zbx_dbstr($delay).' WHERE slideshowid='.zbx_dbstr($slideshowid)))
 			return false;
 
-		DBexecute('DELETE FROM slides where slideshowid='.$slideshowid);
+		DBexecute('DELETE FROM slides where slideshowid='.zbx_dbstr($slideshowid));
 
 		$i = 0;
 		foreach($slides as $slide){
 			$slideid = get_dbid('slides','slideid');
 			if(!isset($slide['delay'])) $slide['delay'] = $delay;
 			$result = DBexecute('INSERT INTO slides (slideid,slideshowid,screenid,step,delay) '.
-				' VALUES ('.$slideid.','.$slideshowid.','.$slide['screenid'].','.($i++).','.$slide['delay'].')');
+				' VALUES ('.$slideid.','.zbx_dbstr($slideshowid).','.zbx_dbstr($slide['screenid']).','.($i++).','.zbx_dbstr($slide['delay']).')');
 			if(!$result){
 				return false;
 			}
@@ -295,9 +294,9 @@
 
 	function delete_slideshow($slideshowid){
 
-		$result = DBexecute('DELETE FROM slideshows where slideshowid='.$slideshowid);
-		$result &= DBexecute('DELETE FROM slides where slideshowid='.$slideshowid);
-		$result &= DBexecute("DELETE FROM profiles WHERE idx='web.favorite.screenids' AND source='slideshowid' AND value_id=$slideshowid");
+		$result = DBexecute('DELETE FROM slideshows where slideshowid='.zbx_dbstr($slideshowid));
+		$result &= DBexecute('DELETE FROM slides where slideshowid='.zbx_dbstr($slideshowid));
+		$result &= DBexecute('DELETE FROM profiles WHERE idx=\'web.favorite.screenids\' AND source=\'slideshowid\' AND value_id='.zbx_dbstr($slideshowid));
 
 		return $result;
 	}
@@ -346,7 +345,7 @@
 		$sql='SELECT h.clock,h.value,i.valuemapid '.
 				' FROM '.$history_table.' h, items i '.
 				' WHERE h.itemid=i.itemid '.
-					' AND i.itemid='.$itemid.
+					' AND i.itemid='.zbx_dbstr($itemid).
 				' ORDER BY h.'.$order_field.' DESC';
 		$result=DBselect($sql,$elements);
 		while($row=DBfetch($result)){
@@ -408,13 +407,13 @@
 		if($config == 0){
 			$sql = 'SELECT screenitemid '.
 			' FROM screens_items '.
-			' WHERE screenid='.$elid.
+			' WHERE screenid='.zbx_dbstr($elid).
 				' AND dynamic='.SCREEN_DYNAMIC_ITEM;
 		}
 		else{
 			$sql = 'SELECT si.screenitemid '.
 			' FROM slides s, screens_items si '.
-			' WHERE s.slideshowid='.$elid.
+			' WHERE s.slideshowid='.zbx_dbstr($elid).
 				' AND si.screenid=s.screenid'.
 				' AND si.dynamic='.SCREEN_DYNAMIC_ITEM;
 		}
@@ -432,8 +431,8 @@
 
 		if(isset($_REQUEST['screenitemid'])){
 			$iresult=DBSelect('SELECT * FROM screens_items'.
-							' WHERE screenid='.$_REQUEST['screenid'].
-								' AND screenitemid='.$_REQUEST['screenitemid']
+							' WHERE screenid='.zbx_dbstr($_REQUEST['screenid']).
+								' AND screenitemid='.zbx_dbstr($_REQUEST['screenitemid'])
 							);
 
 			$form->addVar('screenitemid',$_REQUEST['screenitemid']);
@@ -510,7 +509,7 @@
 							' LEFT JOIN items i ON gi.itemid=i.itemid '.
 							' LEFT JOIN hosts h ON h.hostid=i.hostid '.
 							' LEFT JOIN nodes n ON n.nodeid='.DBid2nodeid('g.graphid').
-						' WHERE g.graphid='.$resourceid);
+						' WHERE g.graphid='.zbx_dbstr($resourceid));
 
 				while($row=DBfetch($result)){
 					$row['node_name'] = isset($row['node_name']) ? '('.$row['node_name'].') ' : '';
@@ -541,7 +540,7 @@
 							' AND h.status='.HOST_STATUS_MONITORED.
 							' AND i.status='.ITEM_STATUS_ACTIVE.
 							' AND '.DBcondition('i.hostid',$available_hosts).
-							' AND i.itemid='.$resourceid);
+							' AND i.itemid='.zbx_dbstr($resourceid));
 
 				while($row=DBfetch($result)){
 					$description_=item_description($row);
@@ -569,7 +568,7 @@
 				$result=DBselect('SELECT n.name as node_name, s.sysmapid,s.name '.
 							' FROM sysmaps s'.
 								' LEFT JOIN nodes n ON n.nodeid='.DBid2nodeid('s.sysmapid').
-							' WHERE s.sysmapid='.$resourceid);
+							' WHERE s.sysmapid='.zbx_dbstr($resourceid));
 
 				while($row=DBfetch($result)){
 					if(!sysmap_accessible($row['sysmapid'],PERM_READ_ONLY)) continue;
@@ -602,7 +601,7 @@
 							' AND h.status='.HOST_STATUS_MONITORED.
 							' AND i.status='.ITEM_STATUS_ACTIVE.
 							' AND '.DBcondition('i.hostid',$available_hosts).
-							' AND i.itemid='.$resourceid);
+							' AND i.itemid='.zbx_dbstr($resourceid));
 
 				while($row=DBfetch($result)){
 					$description_=item_description($row);
@@ -720,7 +719,7 @@
 				$result=DBselect('SELECT DISTINCT n.name as node_name,s.screenid,s.name '.
 							' FROM screens s '.
 								' LEFT JOIN nodes n ON n.nodeid='.DBid2nodeid('s.screenid').
-							' WHERE s.screenid='.$resourceid);
+							' WHERE s.screenid='.zbx_dbstr($resourceid));
 
 				while($row=DBfetch($result)){
 					if(!screen_accessible($row['screenid'], PERM_READ_ONLY)) continue;
@@ -751,7 +750,7 @@
 						' FROM hosts_groups hg, groups g '.
 							' LEFT JOIN nodes n ON n.nodeid='.DBid2nodeid('g.groupid').
 						' WHERE '.DBcondition('g.groupid',$available_groups).
-							' AND g.groupid='.$resourceid);
+							' AND g.groupid='.zbx_dbstr($resourceid));
 
 				while($row=DBfetch($result)){
 					$row['node_name'] = isset($row['node_name']) ? '('.$row['node_name'].') ' : '';
@@ -870,11 +869,11 @@
 		if(is_null($effectiveperiod))
 			$effectiveperiod = ZBX_MIN_PERIOD;
 
-		$result=DBselect('SELECT name,hsize,vsize FROM screens WHERE screenid='.$screenid);
+		$result=DBselect('SELECT name,hsize,vsize FROM screens WHERE screenid='.zbx_dbstr($screenid));
 		$row=DBfetch($result);
 		if(!$row) return new CTableInfo(S_NO_SCREENS_DEFINED);
 				
-		$sql = 'SELECT * FROM screens_items WHERE screenid='.$screenid;
+		$sql = 'SELECT * FROM screens_items WHERE screenid='.zbx_dbstr($screenid);
 		$iresult = DBSelect($sql);
 		
 		$skip_field = array();
@@ -1000,7 +999,7 @@
 
 					$sql = 'SELECT g.graphid, g.show_legend as legend, g.show_3d as show3d '.
 							' FROM graphs g '.
-							' WHERE g.graphid='.$resourceid;
+							' WHERE g.graphid='.zbx_dbstr($resourceid);
 					$res = DBselect($sql);
 					if($graph=DBfetch($res)){
 						$graphid = $graph['graphid'];
@@ -1389,7 +1388,7 @@
 				}
 				else if( ($screenitemid!=0) && ($resourcetype==SCREEN_RESOURCE_TRIGGERS_OVERVIEW) ){
 					$hostids = array();
-					$res = DBselect('SELECT DISTINCT hg.hostid FROM hosts_groups hg WHERE hg.groupid='.$resourceid);
+					$res = DBselect('SELECT DISTINCT hg.hostid FROM hosts_groups hg WHERE hg.groupid='.zbx_dbstr($resourceid));
 					while($tmp_host = DBfetch($res)) $hostids[$tmp_host['hostid']] = $tmp_host['hostid'];
 
 					$item = array(get_triggers_overview($hostids,$style));
@@ -1397,7 +1396,7 @@
 				}
 				else if(($screenitemid!=0) && ($resourcetype==SCREEN_RESOURCE_DATA_OVERVIEW)){
 					$hostids = array();
-					$res = DBselect('SELECT DISTINCT hg.hostid FROM hosts_groups hg WHERE hg.groupid='.$resourceid);
+					$res = DBselect('SELECT DISTINCT hg.hostid FROM hosts_groups hg WHERE hg.groupid='.zbx_dbstr($resourceid));
 					while($tmp_host = DBfetch($res)) $hostids[$tmp_host['hostid']] = $tmp_host['hostid'];
 
 					$item = array(get_items_data_overview($hostids,$style));
